var restatus_timeout = 5000, restatus_counter = 60, restatus_handler = null;

function find_node_by_path(tree, path)
{
    var obj = null;
    $(tree).find("ul").first().find("> li").each(function() {
        if($(this).data("path") == path)
            obj = $(this);
    });
    return obj;
}

function activity2(e)
{
    restatus(null, 1000);

    e.preventDefault();
    e.stopPropagation();
    return false;

}

function activity1(e)
{
    restatus(null, 5000);
}

function restatus(res, tm)
{
    if(tm != null && res == null)
    {
        if(tm >= restatus_timeout)
            return;

        restatus_counter = 60;
        restatus_timeout = tm;
    }
    if(restatus_handler != null)
    {
        clearTimeout(restatus_handler);
        restatus_handler = null;
    }
    $('#status').load("status.php", function() {
        if(restatus_timeout != 30000)
        {
            if(!restatus_counter)
            {
                if(restatus_timeout == 1000)
                    restatus_timeout = 5000;
                else
                    restatus_timeout = 30000;
                restatus_counter = 60;
            }
            else
                if(res != "")
                    restatus_counter--;
        }
        $('#status').append("<br><small>" + restatus_timeout + " " + restatus_counter + "</small>")
        restatus_handler = setTimeout(restatus, restatus_timeout);
    });
}

function recursive_find_node(o, p, i)
{
    if(o = find_node_by_path(o, "/" + p[i]))
    {
        if(i == (p.length - 2))
            return $('#tree').jstree("hover_node", o);

        $('#tree').jstree("open_node", o, function() {
            recursive_find_node(o, p, i + 1);
        });
    }
}
$(function() {
    $.ajaxSetup({
        cache: false
    });


    $('#tree').jstree({
        "core": {"animation": 0},
        "ui": {"select_limit": 1},
        "json_data": {
            "ajax": {
                "url": "filetree.php",
                "cache": false,
                "data": function (n) {
                    return { "path": $(n).data("path") ? $(n).data("path") : "/" };
                }
            }
        },
        "plugins": ["themes", "json_data", "ui"]
    }).on("select_node.jstree", function(event, ui) {
            var c = $(ui.rslt.obj);
            if(c.data("type") == "file")
                $.get("play.php", {"path": c.data("path")}, restatus);
            else
                $('#tree').jstree("toggle_node", c);
    });

    $('body').on("click", ".action", function () {
        $.get("cmd.php", {"cmd": $(this).attr("title")}, restatus);
    });

    $('body').on("click", "div.progress, div.volume", function(e) {
        $.get("cmd.php", {
            "cmd": ($(this).hasClass("volume") ? "volume" : "seek"),
            "pos": ((e.pageX - $(this).offset().left) * 100 / $(this).width()).toFixed(2)},
        restatus);
    }).on("mousemove", "div.progress", activity2);

    $('body').on("mousemove", activity1);

    $('body').on("click", "h3.title", function() {
        $.get("path.php", function(res) {
            recursive_find_node($('#tree'), res.split("\n"), 0);
        });

    });

    restatus();
});

