<?
    class mpcs
    {
        public $port = 7400;
        public $host = "127.0.0.1";
        public $root = "/";

        protected $socket;
        protected $tempfile = "/tmp/jukebox.list";

        static function dirlist($fspath)
        {
            if(!($dh = opendir($fspath)))
                return("opendir() failed");

            $dirents = array();
            while($d = readdir($dh))
            {
                if($d{0} == ".") continue;
                $dirents[] = $d;
            }
            closedir($dh);

            natsort($dirents);

            return $dirents;
        }

        function __construct($root)
        {
            if($this->socket = fsockopen($this->host, $this->port))
                stream_set_timeout($this->socket, 1);

            $this->root = $root;
        }

        function recv()
        {
            return fgets($this->socket);
        }

        function send($cmd)
        {
            fputs($this->socket, $cmd . "\n");
        }


        function play($path)
        {
            $this->send("loadfile \"" . addslashes($this->root . "/" . $path) . "\"");
        }

        function playdir($path)
        {
            $a = explode("/", $path);
            $filename = array_pop($a);
            $dirpath = $this->root . "/" . implode("/", $a);

            if(preg_match('/\.m3u$/i', $filename))
            {
                $this->send("loadlist \"" . addslashes($dirpath . "/" . $filename) . "\"");
                return;
            }

            if(!is_array($dirents = $this->dirlist($dirpath)))
                $dirents = array();

            foreach($dirents as $k => $ent)
                $dirents[$k] = $dirpath . "/" . $ent;

            $all_dirents = $dirents;

            foreach($dirents as $k => $ent)
            {
                if($ent == ($dirpath . "/" . $filename))
                    break;
                unset($dirents[$k]);
            }

            if(!count($dirents))
                $dirents[] = $dirpath . "/" . $filename;


            for($i = 0; $i<10; $i++)
                $dirents = array_merge($dirents, $all_dirents);
            file_put_contents($this->tempfile, implode("\n", $dirents));
            $this->send("loadlist \"" . addslashes($this->tempfile) . "\"");
        }

        protected function get($cmds, $eof_mark)
        {
            $a =  array();
            foreach(explode(",", $cmds) as $c)
                $a[] = "pausing_keep_force " . $c;

            $this->send(implode("\n", $a));

            $res = ""; $t0 = microtime(true);

            while(!preg_match('/(\n|^)' . $eof_mark . '=/', $res))
            {
                if((microtime(true) - $t0) > 1) break;
                $res .= fread($this->socket, 4096);
            }
            $a = array();
            foreach(explode("\n", $res) as $l)
            {
                list($k, $v) = explode("=", $l, 2);
                if(isset($v))
                {
                    if($v{0} == "'" && $v{strlen($v) - 1} == "'")
                        $v = stripslashes(substr($v, 1, strlen($v) - 2));
                    $k = substr($k, 4);
                    $a[$k] = $v;
                }
            }
            return $a;
        }

        function status()
        {
            return $this->get(
                "get_property pause,get_property volume,get_time_length,get_file_name,get_audio_codec,get_audio_bitrate,get_audio_samples,get_meta_title,get_meta_artist,get_meta_album,get_meta_year,get_meta_comment,get_meta_track,get_meta_genre,get_time_pos",
                "ANS_TIME_POSITION");
        }

        function get_path()
        {
            $a = $this->get("get_property path", "ANS_path");
            if(!count($a)) return false;
            return $a["path"];
        }
    }